
#include "rand64.h"

#ifdef WIN32
#if 0
unsigned long long rdtsc64()
{
	unsigned long a, d;
	_asm {
		rdtsc
		mov a,eax
		mov d,edx
	}
	return ((unsigned long long)d << 32) | a;
}
#else
#include <intrin.h>
unsigned long long rdtsc64()
{
	return __rdtsc();
}
#endif
#else
unsigned long long rdtsc64()
{
	unsigned long eax, edx;
	__asm__ volatile("rdtsc" : "=a"(eax), "=d"(edx));
	return ((unsigned long long)edx << 32) | eax;
}
#endif



static unsigned long long value1 = 0xffffffffffffffffULL;
static unsigned long long value2 = 0xffffffffffffffffULL;

void srand64(unsigned long long s)
{
	value1 = s;
}

unsigned long long rand64()
{
	value1 = value1 * 6364136223846793005 + 1442695040888963407;
	return value1;
}

unsigned long long random64()
{
	value2 = value2 * 6364136223846793005 + rdtsc64();
	return value2;
}


